#![allow(non_camel_case_types)]
#![allow(non_upper_case_globals)]
#[derive(Debug, Clone, Copy, PartialEq, Eq, Hash)]
#[repr(i32)]
pub enum ESystemAudioChannel {
    Invalid = 0,
    Aggregated = 1,
    FrontLeft = 2,
    FrontRight = 3,
    LFE = 4,
    BackLeft = 5,
    BackRight = 6,
    FrontCenter = 7,
    Unknown = 8,
    Mono = 9,
}

impl ESystemAudioChannel {
    pub fn from_i32(val: i32) -> Option<Self> {
        match val {
            x if x == Self::Invalid as i32 => Some(Self::Invalid),
            x if x == Self::Aggregated as i32 => Some(Self::Aggregated),
            x if x == Self::FrontLeft as i32 => Some(Self::FrontLeft),
            x if x == Self::FrontRight as i32 => Some(Self::FrontRight),
            x if x == Self::LFE as i32 => Some(Self::LFE),
            x if x == Self::BackLeft as i32 => Some(Self::BackLeft),
            x if x == Self::BackRight as i32 => Some(Self::BackRight),
            x if x == Self::FrontCenter as i32 => Some(Self::FrontCenter),
            x if x == Self::Unknown as i32 => Some(Self::Unknown),
            x if x == Self::Mono as i32 => Some(Self::Mono),
            _ => None,
        }
    }
}
